variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

stages:
- unit_test
- coverage_test
- sonarcloud_check_job

default:
  image : python:3.8.8
  cache:
    paths:
      - .cache/pip
  before_script:
    - python -V
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - pip install -r requirements.txt   # use pipreqs on local machine if use of anaconda


python_run_test_job:
  stage : unit_test  # unitaire , integration , systeme , validation
  script:
    - echo "start code testing "
    - python manage.py test
    - echo "test finished with success"

python_coverage_test_job:
  stage : coverage_test
  script:
    - echo "start coverage testing"
    - coverage run  manage.py test
    - coverage report -m
#    - coverage lcov
#    - cat .coverage
    - echo "coverage test finished"


sonarcloud-check:
  stage: sonarcloud_check_job
  before_script: []
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache

  needs:
    - job: python_coverage_test_job
      artifacts: true 
  script:
    - sonar-scanner